#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include "assert.h"
#include "tally.h"

#define T Tally_T
struct T {
  char aa;
  int count;
  double weight;
  Intlist_T sequences;
  T rest;
};


T
Tally_push (T tally, char aa) {
  T p = (T) malloc(sizeof(*p));
  
  p->aa = aa;
  p->weight = 0.0;
  p->count = 0;
  p->sequences = NULL;
  p->rest = tally;
  return p;
}

void
Tally_free (T *tally) {
  T next;

  for ( ; *tally; *tally = next) {
    Intlist_free(&(*tally)->sequences);
    next = (*tally)->rest;
    free(*tally);
  }
}

char
Tally_aa (T tally) {
  return tally->aa;
}

int
Tally_count (T tally) {
  return tally->count;
}

double
Tally_weight (T tally) {
  return tally->weight;
}

Intlist_T
Tally_sequences (T tally) {
  return tally->sequences;
}

T
Tally_rest (T tally) {
  return tally->rest;
}

int
Tally_length (T tally) {
  int i = 0;

  for ( ; tally; tally = tally->rest) {
    ++i;
  }
  return i;
}
  

void
Tally_addseq (T tally, int seq) {
  ++tally->count;
  tally->sequences = Intlist_push(tally->sequences,seq);
}

T
Tally_findseq (T tally, int seq) {
  for ( ; tally; tally = tally->rest) {
    if (Intlist_find(tally->sequences,seq)) {
      return tally;
    }
  }    
  return NULL;
}

T
Tally_find (T tally, char aa) {
  for ( ; tally; tally = tally->rest) {
    if (tally->aa == aa) {
      return tally;
    }
  }
  return NULL;
}

void
Tally_print (T tally) {
  for ( ; tally; tally = tally->rest) {
    printf("%c:%d ",tally->aa,tally->count);
  }
  printf("\n");
}

  
